<?php

namespace OrganizationsManagement\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\Controller\Simple;
use OrganizationsManagement\Service;
use OrganizationsManagement\Util\Utilities;

class Login  extends Simple {
    /** @var Service\Login\Login $api */
    protected $loginService;

    public function __construct(Service\Login\Login $loginService){
        $this->loginService = $loginService;
    }

    public function validateUserAfterLogin(DTO\Request\Filter $request, DTO\Response $response){
        try {
            $filter = $request->getFilterCriteria()->getConditions();
            $operatorCode = Utilities::getValueInFilterDataSourceByName($filter, 'CDOPERADOR', true);
            $orgId        = Utilities::getValueInFilterDataSourceByName($filter, 'NRORG', true);
            $validation   = $this->loginService->validateUserAfterLogin($operatorCode, $orgId);
            $response->addDataSet(new DataSource\DataSet('userValidation', array($validation)));
        } catch (\Exception $ex){
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }
} 