<?php

namespace OrganizationsManagement\Controller;
use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use OrganizationsManagement\Service;
use OrganizationsManagement\Util\Messages;
use OrganizationsManagement\Util\InstanceProvider;

class SMIntegration extends Simple
{
    
    public function findSMIntegrationURL(DTO\Request\Filter $request, DTO\Response $response)
    {
        $dataSet = InstanceProvider::getService()->getSMIntegration()->findSMIntegrationURL();
        $response->addDataSet(new DataSet('findSMIntegrationURL', $dataSet));
    }
    public function findSMParameters(DTO\Request\Filter $request, DTO\Response $response)
    {
        $filter = $request->getFilterCriteria()->getConditions();
        $dataSet = InstanceProvider::getService()->getSMIntegration()->findSMParameters($filter);
        $smUrl = InstanceProvider::getService()->getSMIntegration()->findSMIntegrationURL();
        $dataSet[0]["ID"] = $smUrl[0]["ID"];
        $dataSet[0]["DSURLSM"] = $smUrl[0]["DSURLSM"];
        $response->addDataSet(new DataSet('findSMParameters', $dataSet));
    }
    public function findBudgetModel(DTO\Request\Filter $request, DTO\Response $response)
    {
        $filter = $request->getFilterCriteria()->getConditions();
        $dataSet = InstanceProvider::getService()->getSMIntegration()->findBudgetModel($filter);
        $response->addDataSet(new DataSet('findBudgetModel', $dataSet));
    }
    public function priceCustomization(DTO\Request\Filter $request, DTO\Response $response)
    {
        $filter = $request->getFilterCriteria()->getConditions();
        $dataSet = InstanceProvider::getService()->getSMIntegration()->priceCustomization($filter);
        $response->addDataSet(new DataSet('priceCustomuzation', $dataSet));
    }
    
    public function lsFindSMIntegration(DTO\Request\Filter $request, DTO\Response $response)
    {
        $filter = $request->getFilterCriteria()->getConditions();
        $dataSet = InstanceProvider::getService()->getSMIntegration()->lsFindSMIntegration($filter);
        $response->addDataSet(new DataSet('ls_findSMIntegration', $dataSet));
    }
    
    public function finditorcaprod(DTO\Request\Filter $request, DTO\Response $response)
    {
        $dataSet = InstanceProvider::getService()->getSMIntegration()->finditorcaprod();
        $response->addDataSet(new DataSet('finditorcaprod', $dataSet));
    }
    
    public function findservorca(DTO\Request\Filter $request, DTO\Response $response)
    {
        $dataSet = InstanceProvider::getService()->getSMIntegration()->findservorca();
        $response->addDataSet(new DataSet('findservorca', $dataSet));
    }
    
    public function findItemprodorca(DTO\Request\Filter $request, DTO\Response $response)
    {
        $filter = $request->getFilterCriteria()->getConditions();
        $dataSet = InstanceProvider::getService()->getSMIntegration()->findItemprodorca($filter);
        $response->addDataSet(new DataSet('findItemprodorca', $dataSet));
    }

    public function smIntegrationSaveURL(DTO\Request $request, DTO\Response $response)
    {
        $requestRow = $request->getDataSet()->getRows()[0];
        $url = $requestRow['DSURLSM'];
        $id = isset($requestRow['ID']) ? $requestRow['ID'] : null;
        $changed = $requestRow['changed'];
        InstanceProvider::getService()->getSMIntegration()->smIntegrationSaveURL($id, $url, $changed);
    }
    
    public function saveItemprodorcaFctItemorcamento(DTO\Request $request, DTO\Response $response)
    {
        $requestRow = $request->getDataSet()->getRows()[0];
        $cdservorca = $requestRow['CDSERVORCA'];
        $cditorcaprod = $requestRow['CDITORCAPROD'];
        $id = $requestRow['ID'];
        InstanceProvider::getService()->getSMIntegration()->saveItemprodorcaFctItemorcamento($cdservorca, $cditorcaprod, $id);
    }

    public function findServicoOrca(DTO\Request\Filter $request, DTO\Response $response)
    {
        $filter = $request->getFilterCriteria()->getConditions();
        $page     = $request->getFilterCriteria()->getPage();
        $pageSize = $request->getFilterCriteria()->getPageSize();
        $dataSet = InstanceProvider::getService()->getSMIntegration()->findServicoOrca($filter, $page, $pageSize);
        $response->addDataSet(new DataSet('findServicoOrca', $dataSet));
    }

    public function saveServicoOrca(DTO\Request $request, DTO\Response $response)
    {
        $requestRow = $request->getDataSet()->getRows()[0];
        $cdservorca = $requestRow['CDSERVORCA'];
        $nmservorca = $requestRow['NMSERVORCA'];
        $dsservorca = $requestRow['DSSERVORCA'];
        $idlicenusomanut = $requestRow['IDLICENUSOMANUT'];
        InstanceProvider::getService()->getSMIntegration()->smIntegrationSaveServiOrca($cdservorca, $nmservorca, $dsservorca, $idlicenusomanut);
    }

    public function findProductLineServOrca(DTO\Request\Filter $request, DTO\Response $response)
    {
        $dataSet = InstanceProvider::getService()->getSMIntegration()->findProductLineServOrca();
        $response->addDataSet(new DataSet('findProductLicenseServOrca', $dataSet));
    }

    public function saveProductLineServOrca(DTO\Request\DataSet $request, DTO\Response $response)
    {
        $requestRow = $request->getDataSet()->getRows()[0];
        $cdservorcaLU      = isset($requestRow['CDSERVORCA_LU']) ? $requestRow['CDSERVORCA_LU'] : null;
        $cdservorcaMA      = isset($requestRow['CDSERVORCA_MA']) ? $requestRow['CDSERVORCA_MA'] : null;
        $nrtipoorcamentoMA = isset($requestRow['NRTIPOORCAMENTO_MA']) ? $requestRow['NRTIPOORCAMENTO_MA'] : null;
        $percentualMA      = isset($requestRow['MAINTENANCE_PERCENTAGE']) ? $requestRow['MAINTENANCE_PERCENTAGE'] : null;
        
        InstanceProvider::getService()->getSMIntegration()->smIntegrationSaveServiOrca($cdservorcaLU, $cdservorcaMA, null, $nrtipoorcamentoMA, $percentualMA);
    }

    public function saveSMParameters(DTO\Request $request, DTO\Response $response)
    {
        $requestRow = $request->getDataSet()->getRows()[0];
        $url = $requestRow['DSURLSM'];
        $id = isset($requestRow['ID']) ? $requestRow['ID'] : null;
        // Relacionados a Tabela Principal
        $nrParametroGeral = $requestRow['NRPARAMETROGERAL'];
        $idIntegracaoOm = $requestRow['IDINTEGRACAOOM'];
        $urlIntegracaoOm = $requestRow['URLINTEGRACAOOM'];
        $idIntegracaoCrm = $requestRow['IDINTEGRACAOCRM'];
        $urlIntegracaoCrm =  $requestRow['URLINTEGRACAOCRM'];
        // Tabela para ligar com fct_orcamentomodelo
        $nrOrcaModeloCust = $requestRow['NRORCAMODELOCUST'];
        // Tabela para ligar com fct_precbaseserv
        $cdPrecBaseServCust = $requestRow['CDPRECBASESERVCUST'];

        // Relacionados a Tabela 'FCT_ORCAMENTOMODELO'
        $nmOrcaModeloCust =  $requestRow['NMORCAMODELOCUST'];
        // Relacionados a Tabela FCT_PRECBASESERV
        $dsPrecBaseServCust = $requestRow['DSPRECBASESERVCUST'];
        InstanceProvider::getService()->getSMIntegration()->smIntegrationSaveURL($id, $url);
        InstanceProvider::getService()->getSMIntegration()->smIntegrationSaveParameters($nrParametroGeral, $idIntegracaoOm,$urlIntegracaoOm,$idIntegracaoCrm,$urlIntegracaoCrm, $nrOrcaModeloCust, $cdPrecBaseServCust);
    }
    
    public function lsFindServices(DTO\Request\Filter $request, DTO\Response $response)
    {
        $filter   = $request->getFilterCriteria()->getConditions();
        $page     = $request->getFilterCriteria()->getPage();
        $pageSize = $request->getFilterCriteria()->getPageSize();
        $dataSet  = InstanceProvider::getService()->getSMIntegration()->lsFindServices($filter, $page, $pageSize);
        $response->addDataSet(new DataSet('lsFindServices', $dataSet));
    }

    public function findBudgetItems(DTO\Request\Filter $request, DTO\Response $response)
    {
        $filter   = $request->getFilterCriteria()->getConditions();
        $page     = $request->getFilterCriteria()->getPage();
        $pageSize = $request->getFilterCriteria()->getPageSize();
        $dataSet  = InstanceProvider::getService()->getSMIntegration()->findBudgetItems($filter, $page, $pageSize);
        $response->addDataSet(new DataSet('budgetItems', $dataSet));
    }
    
    public function smIntegrationImportValues(DTO\Request $request, DTO\Response $response)
    {
         $requestRow = $request->getDataSet()->getRows()[0];
         InstanceProvider::getService()->getSMIntegration()->smIntegrationImportValues($requestRow);
    }
    
    public function smIntegrationSave(DTO\Request $request, DTO\Response $response)
    {
         $requestRow = $request->getDataSet()->getRows()[0];
         $id = $requestRow['ID'];
         $cdServOrca = $requestRow['CDSERVORCA'];
         $budgetItemId = $requestRow['BUDGETID'];
         InstanceProvider::getService()->getSMIntegration()->smIntegrationSave($id, $cdServOrca, $budgetItemId);
    }
    
    public function findTipoOrcamento(DTO\Request\Filter $request, DTO\Response $response)
    {
        $filter = $request->getFilterCriteria()->getConditions();
        $page     = $request->getFilterCriteria()->getPage();
        $pageSize = $request->getFilterCriteria()->getPageSize();
        $dataSet = InstanceProvider::getService()->getSMIntegration()->findTipoOrcamento($filter, $page, $pageSize);
        $response->addDataSet(new DataSet('findTipoOrcamento', $dataSet));
    }
}