<?php
namespace OrganizationsManagement\Util\Instance;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DependencyInjection\InstanceManager;


class Service {

    /** @return  Service */
    public static function getInstance()
    {
        return new static();
    }
    
    /** @return  \OrganizationsManagement\Service\NotificationServiceso */
    public function getNotificationServices()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Service\NotificationServices');
    }
    
    public function getNotificationServicesApp()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Service\NotificationServicesApp');
    }
    
    public function getNotificationServicesDev()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Service\NotificationServicesDev');
    }
    
    public function getNotificationParameters()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Service\NotificationParameters');
    }

    /** @return  \OrganizationsManagement\Service\Organizacao */
    public function getOrganizacao()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Service\Organizacao');
    }
    
    /** @return  \OrganizationsManagement\Service\Elemento */
    public function getElemento()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Service\Elemento');
    }

    /** @return  \OrganizationsManagement\Service\OrgElemento */
    public function getOrgElemento()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Service\OrgElemento');
    }

    /** @return  \OrganizationsManagement\Service\SMIntegration */
    public function getSMIntegration()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Service\SMIntegration');
    }

    /** @return  \OrganizationsManagement\Service\StructureUpdate */
    public function getStructureUpdate()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Service\StructureUpdate');
    }

    /** @return  \OrganizationsManagement\Service\CRMIntegration */
    public static function getCRMIntegration()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Service\CRMIntegration');
    }

    /** @return  \OrganizationsManagement\Service\ServerMnemonic
     * @throws \Exception
     */
    public static function getServerMnemonic()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Service\ServerMnemonic');
    }


    /** @return  \OrganizationsManagement\Service\Produto
     * @throws \Exception
     */
    public static function getProduto()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Service\Produto');
    }

    /** @return  \OrganizationsManagement\Service\Commands
     * @throws \Exception
     */
    public static function getCommands()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Service\Commands');
    }

    /** @return  \OrganizationsManagement\Service\FileSendingSolicitationDelphi
     * @throws \Exception
     */
    public static function getFileUploadRequestDelphi()
    {
        return InstanceManager::getInstance()->getService('\OrganizationsManagement\Service\FileSendingSolicitationDelphi');
    }
}