/******************************************************************************/
/* TEKNISA                                                                    */
/******************************************************************************/
/*                                                                            */
/* NOME: GRAVA_LOGAUTOFORNE                                                      */
/*                                                                            */
/* DESCRIO:                                                                 */
/*   Grava log de AUTOFORNE                                                   */
/*                                                                            */
/* CRIAO:                                                                   */
/* 18/02/2004 - Luiz Otvio de Souza                                          */
/*                                                                            */
/******************************************************************************/

/*
@C:\WEB_410\Sql\End_Conv\Oracle\8780_SUPTRGO_GRAVA_LOGAUTOFORNE.SQL
*/

CREATE OR REPLACE TRIGGER GRAVA_LOGAUTOFORNE
AFTER INSERT OR UPDATE OR DELETE
ON AUTOFORNE FOR EACH ROW

DECLARE
   V_IDGRAVLOGAF VARCHAR2(03);
   V_DSRDMUSULAF  VARCHAR2(50);
   V_DSENDUSULAF  VARCHAR2(50);
   V_DSNMUSULAF   VARCHAR2(50);
   V_DSMETUSULAF  VARCHAR2(250);
   V_CDOPERLOGAF  VARCHAR2(12);

BEGIN
   SELECT NVL(MAX(IDGRAVLOGAF), 'SSS')
   INTO V_IDGRAVLOGAF
   FROM PARASUPRI
   WHERE (CDFILIAL = (SELECT NVL(CDFILCENTCMP, CDFILIAL)
                      FROM FILIAL
                      WHERE (CDFILIAL = NVL(:NEW.CDFILDEST, :OLD.CDFILDEST))));

   WEBTUNNING(V_DSENDUSULAF, V_DSNMUSULAF, V_DSRDMUSULAF, V_DSMETUSULAF, V_CDOPERLOGAF);

   IF INSERTING THEN
      IF SUBSTR(V_IDGRAVLOGAF, 1, 1) = 'S' THEN
         INSERT INTO LOGAUTOFORNE
         (CDFILDESLAF,  CDFILLANLAF,  NRAUTFORLAF,  VRTOTALAFANT, VRTOTALAFDEP, IDSITUAAFANT,
          IDSITUAAFDEP, IDAFFORLIANT, IDAFFORLIDEP, IDBAIXAAFANT, IDBAIXAAFDEP, CDFORMPGTANT,
          CDFORMPGTDEP, DSINCONAFANT, DSINCONAFDEP, IDOPERACLAF,  DSRDMUSULAF,  DSENDUSULAF,
          DSNMUSULAF,   DSMETUSULAF,  CDOPERLOGAF,  DTOPERALAF, NRSEQENVIOAFORN)
         VALUES
         (:NEW.CDFILDEST, :NEW.CDFILLANC, :NEW.NRAUTOFORN, 0, :NEW.VRTOTALAF, NULL,
          :NEW.IDSITUATUAAF, NULL, :NEW.IDAFFORALIM, NULL, :NEW.IDBAIXAAF, NULL,
          :NEW.CDFORMPGTO, NULL, :NEW.DSINCONSAF, 'I', V_DSRDMUSULAF, V_DSENDUSULAF,
          V_DSNMUSULAF, V_DSMETUSULAF, V_CDOPERLOGAF, SYSDATE, :NEW.NRSEQENVIOAFORN);
      END IF;
   END IF;

   IF UPDATING THEN
      IF SUBSTR(V_IDGRAVLOGAF, 2, 1) = 'S' THEN
         INSERT INTO LOGAUTOFORNE
         (CDFILDESLAF,  CDFILLANLAF,  NRAUTFORLAF,  VRTOTALAFANT, VRTOTALAFDEP, IDSITUAAFANT,
          IDSITUAAFDEP, IDAFFORLIANT, IDAFFORLIDEP, IDBAIXAAFANT, IDBAIXAAFDEP, CDFORMPGTANT,
          CDFORMPGTDEP, DSINCONAFANT, DSINCONAFDEP, IDOPERACLAF,  DSRDMUSULAF,  DSENDUSULAF,
          DSNMUSULAF,   DSMETUSULAF,  CDOPERLOGAF,  DTOPERALAF, NRSEQENVIOAFORN)
         VALUES
         (:OLD.CDFILDEST, :OLD.CDFILLANC, :OLD.NRAUTOFORN, 0, :NEW.VRTOTALAF, :OLD.IDSITUATUAAF,
          :NEW.IDSITUATUAAF, :OLD.IDAFFORALIM, :NEW.IDAFFORALIM, :OLD.IDBAIXAAF, :NEW.IDBAIXAAF, :OLD.CDFORMPGTO,
          :NEW.CDFORMPGTO, :OLD.DSINCONSAF, :NEW.DSINCONSAF, 'A', V_DSRDMUSULAF, V_DSENDUSULAF,
          V_DSNMUSULAF, V_DSMETUSULAF, V_CDOPERLOGAF, SYSDATE, NVL(:OLD.NRSEQENVIOAFORN, :NEW.NRSEQENVIOAFORN));
      END IF;
   END IF;

   IF DELETING THEN
      IF SUBSTR(V_IDGRAVLOGAF, 3, 1) = 'S' THEN
         INSERT INTO LOGAUTOFORNE
         (CDFILDESLAF,  CDFILLANLAF,  NRAUTFORLAF,  VRTOTALAFANT, VRTOTALAFDEP, IDSITUAAFANT,
          IDSITUAAFDEP, IDAFFORLIANT, IDAFFORLIDEP, IDBAIXAAFANT, IDBAIXAAFDEP, CDFORMPGTANT,
          CDFORMPGTDEP, DSINCONAFANT, DSINCONAFDEP, IDOPERACLAF,  DSRDMUSULAF,  DSENDUSULAF,
          DSNMUSULAF,   DSMETUSULAF,  CDOPERLOGAF,  DTOPERALAF, NRSEQENVIOAFORN)
         VALUES
         (:OLD.CDFILDEST, :OLD.CDFILLANC, :OLD.NRAUTOFORN, 0, :OLD.VRTOTALAF, :OLD.IDSITUATUAAF,
          :OLD.IDSITUATUAAF, :OLD.IDAFFORALIM, :OLD.IDAFFORALIM, :OLD.IDBAIXAAF, :OLD.IDBAIXAAF, :OLD.CDFORMPGTO,
          :OLD.CDFORMPGTO, :OLD.DSINCONSAF, :OLD.DSINCONSAF, 'E', V_DSRDMUSULAF, V_DSENDUSULAF,
          V_DSNMUSULAF, V_DSMETUSULAF, V_CDOPERLOGAF, SYSDATE, :OLD.NRSEQENVIOAFORN);
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GRAVA_LOGAUTOFORNE','4.11.076'); END;
/

