create or replace PROCEDURE EAM_IMPORTA_RESPONSAVEL(V_ERRO OUT VARCHAR2)
IS
   V_NRINSJURCLIE VARCHAR2(20);
   V_NMRAZSOCCLIE VARCHAR2(50);
   V_CDPAIS       VARCHAR2(4);
   V_SGESTADO     VARCHAR2(2);
   V_CDMUNICIBGE  VARCHAR2(7);
   V_DSENDECLIE   VARCHAR2(50);
   V_NRCEPCLIE    VARCHAR2(15);
   V_CPF          VARCHAR2(20);
   V_DIGITO       VARCHAR2(5);
   V_CDCLIENTE    VARCHAR2(20);
   V_CDMUNICIPIO  VARCHAR2(4);
   V_USR_CODINTER VARCHAR2(20);
   V_IDSTATUS     VARCHAR2(1);
   V_CONTADOR INTEGER;

   CURSOR C_RESPONSAVEL IS
      SELECT NRINSJURCLIE, NMRAZSOCCLIE, CDPAIS, SGESTADO, CDMUNICIBGE, DSENDECLIE, NRCEPCLIE, USR_CODINTERNO, IDSTATUS
        FROM USR_EAM_RESPONSAVEL
       WHERE DTIMPORTACAO IS NULL
         AND ERRO IS NULL;
   PROCEDURE VALIDA_CPF(P_NUMERO IN VARCHAR2, P_DIGITO IN OUT VARCHAR2)
   IS
      V_ERRO VARCHAR2(500);
      V_LOOP VARCHAR2(20);
      I_CALC INTEGER;
      I_SUBT INTEGER;
      F_CALC FLOAT;
   BEGIN
      I_CALC := LENGTH(P_NUMERO)+1;
      I_SUBT := 1;
      F_CALC := 0;
      LOOP
         EXIT WHEN I_CALC = 1;
         F_CALC := F_CALC+(SUBSTR(P_NUMERO,I_SUBT,1)*I_CALC);
         I_CALC := I_CALC-1;
         I_SUBT := I_SUBT+1;
      END LOOP;
      F_CALC := 11-MOD(F_CALC,11);
      IF (F_CALC > 9) THEN
         F_CALC := 0;
      END IF;
      P_DIGITO := P_DIGITO||F_CALC;
      IF LENGTH(P_DIGITO) < 2 THEN
         VALIDA_CPF(P_NUMERO||P_DIGITO, P_DIGITO);
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
         V_ERRO := SQLERRM(SQLCODE);
   END;
BEGIN
   OPEN C_RESPONSAVEL;
   LOOP
      FETCH C_RESPONSAVEL INTO V_NRINSJURCLIE, V_NMRAZSOCCLIE, V_CDPAIS, V_SGESTADO, V_CDMUNICIBGE, V_DSENDECLIE, V_NRCEPCLIE, V_USR_CODINTER, V_IDSTATUS;
      EXIT WHEN C_RESPONSAVEL%NOTFOUND;
      BEGIN
         BEGIN
            SELECT CDCLIENTE
              INTO V_CDCLIENTE
              FROM CLIENTE
             WHERE USR_CODINTERNO = V_USR_CODINTER;
         EXCEPTION
            WHEN OTHERS THEN
               V_CDCLIENTE := NULL;
         END;
         SELECT REGEXP_REPLACE(V_NRINSJURCLIE, '\D')
           INTO V_CPF
           FROM DUAL;
         IF (V_IDSTATUS IN ('I', 'U')) THEN
            IF ((V_CDCLIENTE IS NULL) AND (V_IDSTATUS = 'I')) THEN
               SELECT COUNT(1)
                 INTO V_CONTADOR
                 FROM PAIS
                WHERE CDPAIS = V_CDPAIS;
               IF (V_CONTADOR = 1) THEN
                  SELECT COUNT(1)
                    INTO V_CONTADOR
                    FROM ESTADO
                   WHERE CDPAIS   = V_CDPAIS
                     AND SGESTADO = V_SGESTADO;
                  IF (V_CONTADOR = 1) THEN
                     BEGIN
                        SELECT CDMUNICIPIO
                          INTO V_CDMUNICIPIO
                          FROM MUNICIPIO
                         WHERE CDPAIS      = V_CDPAIS
                           AND SGESTADO    = V_SGESTADO
                           AND CDMUNICIBGE = V_CDMUNICIBGE;
                     EXCEPTION
                        WHEN DUP_VAL_ON_INDEX THEN
                           V_ERRO := 'MAIS DE UM REGISTRO COM O CDIGO '||V_CDMUNICIBGE;
                           V_CDMUNICIPIO := NULL;
                        WHEN NO_DATA_FOUND THEN
                           V_ERRO := 'NO FOI ENCONTRADO MUNICPIO COM O CDIGO '||V_CDMUNICIBGE;
                           V_CDMUNICIPIO := NULL;
                     END;
                     IF (V_CDMUNICIPIO IS NOT NULL) THEN
                        VALIDA_CPF(SUBSTR(V_CPF,1,9), V_DIGITO);
                        IF (V_DIGITO = SUBSTR(V_CPF,-2)) THEN
                           BEGIN
                              V_CDCLIENTE := 'F'||V_CPF;
                              INSERT INTO CLIENTE(CDCLIENTE, IDTPIJURCLIE, NRINSJURCLIE, NMRAZSOCCLIE, NMFANTCLIE, USR_CODINTERNO)
                              VALUES(V_CDCLIENTE, 'F', V_CPF, V_NMRAZSOCCLIE, V_NMRAZSOCCLIE, V_USR_CODINTER);
                              INSERT INTO ENDECLIE(CDCLIENTE, IDTPENDECLIE, CDPAIS, SGESTADO, CDMUNICIPIO, DSENDECLIE, NRCEPCLIE)
                              VALUES(V_CDCLIENTE, 'P', V_CDPAIS, V_SGESTADO, V_CDMUNICIPIO, V_DSENDECLIE, V_NRCEPCLIE);
                           EXCEPTION
                              WHEN OTHERS THEN
                                 ROLLBACK;
                                 V_ERRO := SQLERRM(SQLCODE);
                           END;
                        ELSE
                           V_ERRO := 'CPF '||V_NRINSJURCLIE||' DO CLIENTE '||V_NMRAZSOCCLIE||'  INVLIDO';
                        END IF;
                     END IF;
                  ELSE
                     V_ERRO := 'SIGLA DE ESTADO '||V_SGESTADO||' NO FOI CADASTRADO';
                  END IF;
               ELSE
                  V_ERRO := 'CDIGO DE PAS '||V_CDPAIS||' NO CADASTRADO';
               END IF;
            ELSIF ((V_CDCLIENTE IS NOT NULL) AND (V_IDSTATUS = 'U')) THEN
               VALIDA_CPF(SUBSTR(V_CPF,1,9), V_DIGITO);
               IF (V_DIGITO = SUBSTR(V_CPF,-2)) THEN
                  BEGIN
                     SELECT CDMUNICIPIO
                       INTO V_CDMUNICIPIO
                       FROM MUNICIPIO
                      WHERE CDPAIS      = V_CDPAIS
                        AND SGESTADO    = V_SGESTADO
                        AND CDMUNICIBGE = V_CDMUNICIBGE;
                  EXCEPTION
                     WHEN DUP_VAL_ON_INDEX THEN
                        V_ERRO := 'MAIS DE UM REGISTRO COM O CDIGO '||V_CDMUNICIBGE;
                        V_CDMUNICIPIO := NULL;
                     WHEN NO_DATA_FOUND THEN
                        V_ERRO := 'NO FOI ENCONTRADO MUNICPIO COM O CDIGO '||V_CDMUNICIBGE;
                        V_CDMUNICIPIO := NULL;
                  END;

                  IF (V_CDMUNICIPIO IS NOT NULL) THEN
                     UPDATE CLIENTE
                        SET NRINSJURCLIE = V_CPF,
                            NMRAZSOCCLIE = V_NMRAZSOCCLIE,
                            NMFANTCLIE   = V_NMRAZSOCCLIE
                      WHERE CDCLIENTE    = V_CDCLIENTE;
                     UPDATE ENDECLIE
                        SET CDPAIS      = V_CDPAIS,
                            SGESTADO    = V_SGESTADO,
                            CDMUNICIPIO = V_CDMUNICIPIO,
                           DSENDECLIE   = V_DSENDECLIE,
                           NRCEPCLIE    = V_NRCEPCLIE
                      WHERE CDCLIENTE   = V_CDCLIENTE;
                   END IF;
               ELSE
                  V_ERRO := 'CPF '||V_NRINSJURCLIE||' DO CLIENTE '||V_NMRAZSOCCLIE||'  INVLIDO';
               END IF;
            ELSIF ((V_CDCLIENTE IS NULL) AND (V_IDSTATUS = 'U')) THEN
               V_ERRO := 'NO FOI POSSVEL ATUALIZAR O RESPONSVEL '||V_NRINSJURCLIE||'-'||V_NMRAZSOCCLIE||'. RESPONSVEL NO CADASTRADO';
            ELSIF ((V_CDCLIENTE IS NOT NULL) AND (V_IDSTATUS = 'I')) THEN
               V_ERRO := 'RESPONSVEL '||V_NRINSJURCLIE||'-'||V_NMRAZSOCCLIE||' J CADASTRADO';
            END IF;
         ELSE
            IF (V_CDCLIENTE IS NOT NULL) THEN
               UPDATE CLIENTE
                  SET IDCLIEATIV = 'N'
                WHERE CDCLIENTE = V_CDCLIENTE;
            ELSE
               V_ERRO := 'NO FOI POSSVEL EXCLUIR O RESPONSVEL '||V_NRINSJURCLIE||'-'||V_NMRAZSOCCLIE||'. RESPONSVEL NO CADASTRADO';
            END IF;            
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
            V_ERRO := SQLERRM(SQLCODE);
      END;
      IF (V_ERRO IS NOT NULL) THEN
         UPDATE USR_EAM_RESPONSAVEL
            SET ERRO = V_ERRO
          WHERE NRINSJURCLIE = V_NRINSJURCLIE;
      ELSE
         UPDATE USR_EAM_RESPONSAVEL
            SET DTIMPORTACAO = SYSDATE
          WHERE NRINSJURCLIE = V_NRINSJURCLIE;
      END IF;
      COMMIT;
   END LOOP;
   CLOSE C_RESPONSAVEL;
   COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF C_RESPONSAVEL%ISOPEN THEN
         CLOSE C_RESPONSAVEL;
      END IF;
      V_ERRO := SQLERRM(SQLCODE);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EAM_IMPORTA_RESPONSAVEL','6.25.xxx'); END;
/