/*
 TECNISA - TECNOLOGIA EM INFORMTICA

 NOME: CONHECIMENTO_TRANSPORTE

 DESCRIO:
  PROCEDIMENTO PARA ATUALIZAO DO VALOR DE ESTOQUE DOS TENS COM
  O VALOR DO CONHECIMENTO DE TRANSPORTE

 CRIAO:
 13/08/2001 - ROBERTO A. LOPES MARTINS

 C:\WIN_PRJ\SQL\END_CONV\SQLSERVER\5007_DFESTP_CONHECIMENTO_TRANSPORTE.SQL
*/

IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'CONHECIMENTO_TRANSPORTE' AND
                 O.TYPE = 'P' 			             AND
                 U.UID = O.UID             	       AND
                 U.NAME = USER)
DROP PROCEDURE CONHECIMENTO_TRANSPORTE
GO

CREATE PROCEDURE CONHECIMENTO_TRANSPORTE
                 @P_CDFILIAL   VARCHAR(04),
                 @P_NRLANCTONF VARCHAR(10),
                 @P_NRLANCESTQ VARCHAR(10)
AS
   DECLARE @V_VRLIQUFRETE  FLOAT;
   DECLARE @V_VRBRUTFRETE  FLOAT;
   DECLARE @V_VRTTLANESTQ  FLOAT;
   DECLARE @V_VRTTLANBRUT  FLOAT;
   DECLARE @V_VRTTCUSENTR  FLOAT;

   DECLARE @V_VRLANCTOEST  FLOAT;
   DECLARE @V_VRLANCTOBRUT FLOAT;
   DECLARE @V_VRCUSTENTR   FLOAT;

   /*VARIVEIS DO CURSOR C_RATEIO*/
   DECLARE @V_RATEIO_NRSEQUITEM   VARCHAR(04);
   DECLARE @V_RATEIO_VRLANCTOEST  FLOAT;
   DECLARE @V_RATEIO_VRLANCTOBRUT FLOAT;
   DECLARE @V_RATEIO_QTITEMPROD   FLOAT;

   /*VARIVEIS DO CURSOR C_NOTA*/
   DECLARE @V_NOTA_CDFILIALIT     VARCHAR(04);
   DECLARE @V_NOTA_NRLANCTONFIT   VARCHAR(10);
BEGIN
   DECLARE C_NOTA CURSOR FOR
   SELECT CDFILIALIT, NRLANCTONFIT
   FROM ITEMNOTAFISC
   WHERE CDFILIAL   = @P_CDFILIAL AND
         NRLANCTONF = @P_NRLANCTONF;

   OPEN C_NOTA;
   FETCH NEXT FROM C_NOTA INTO @V_NOTA_CDFILIALIT, @V_NOTA_NRLANCTONFIT;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      SELECT @V_VRTTLANESTQ = SUM(VRCONTITEM),
             @V_VRTTLANBRUT = SUM(VRBRUTITEM),
             @V_VRTTCUSENTR = SUM(VRCONTITEM)
      FROM ITEMPRODUTO I, ITEMNOTAFISC II
      WHERE II.CDFILIALIT    = @V_NOTA_CDFILIALIT   AND
            II.NRLANCTONFIT  = @V_NOTA_NRLANCTONFIT AND
            II.CDFILIAL      = I.CDFILIAL           AND
            II.NRLANCTONF    = I.NRLANCTONF;

      SELECT @V_VRLIQUFRETE = SUM(VRCONTITEM),
             @V_VRBRUTFRETE = SUM(VRBRUTITEM)
      FROM ITEMPRODUTO IP, ITEMNOTAFISC T
      WHERE T.CDFILIAL   = @P_CDFILIAL       AND
            T.NRLANCTONF = @P_NRLANCTONF     AND
            IP.CDFILIAL = T.CDFILIALIT      AND
            IP.NRLANCTONF = T.NRLANCTONFIT;

      FETCH NEXT FROM C_NOTA INTO @V_NOTA_CDFILIALIT, @V_NOTA_NRLANCTONFIT;
   END;
   CLOSE C_NOTA;
   DEALLOCATE C_NOTA;

   IF @V_VRBRUTFRETE IS NOT NULL BEGIN
      DECLARE C_RATEIO CURSOR FOR
      SELECT I.NRSEQITPROD,
             VRCONTITEM AS VRLANCTOEST,
             VRBRUTITEM AS VRLANCTOBRUT,
             (I.QTITEMPROD * P.VRFATOCONV) AS QTITEMPROD
      FROM PRODUTO P, ITEMPRODUTO I
      WHERE I.CDFILIAL   = @P_CDFILIAL   AND
            I.NRLANCTONF = @P_NRLANCTONF AND
            I.CDPRODUTO  = P.CDPRODUTO;

      OPEN C_RATEIO;
      FETCH NEXT FROM C_RATEIO INTO @V_RATEIO_NRSEQUITEM,   @V_RATEIO_VRLANCTOEST,
                                    @V_RATEIO_VRLANCTOBRUT, @V_RATEIO_QTITEMPROD;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         SET @V_VRLANCTOEST = (@V_RATEIO_VRLANCTOEST/@V_VRTTLANESTQ) * @V_VRLIQUFRETE;
         SET @V_VRLANCTOBRUT = (@V_RATEIO_VRLANCTOBRUT/@V_VRTTLANBRUT) * @V_VRBRUTFRETE;
         SET @V_VRCUSTENTR = (@V_RATEIO_VRLANCTOEST/@V_VRTTCUSENTR) * @V_VRLIQUFRETE;

         IF @V_RATEIO_QTITEMPROD <> 0 BEGIN
            SET @V_VRLANCTOEST  = (@V_VRLANCTOEST/@V_RATEIO_QTITEMPROD);
            SET @V_VRLANCTOBRUT = (@V_VRLANCTOBRUT/@V_RATEIO_QTITEMPROD);
         END;

         UPDATE ITLANCTOEST
         SET VRLANCTOEST  = VRLANCTOEST  + @V_VRLANCTOEST,
             VRLANCTOBRUT = VRLANCTOBRUT + @V_VRLANCTOBRUT,
             VRCUSTENTR   = VRCUSTENTR   + @V_VRCUSTENTR
         WHERE CDFILIAL   = @P_CDFILIAL   AND
               NRLANCESTQ = @P_NRLANCESTQ AND
               NRSEQUITEM = @V_RATEIO_NRSEQUITEM;

         FETCH NEXT FROM C_RATEIO INTO @V_RATEIO_NRSEQUITEM,   @V_RATEIO_VRLANCTOEST,
                                       @V_RATEIO_VRLANCTOBRUT, @V_RATEIO_QTITEMPROD;

      END;
      CLOSE C_RATEIO;
      DEALLOCATE C_RATEIO;
   END;
END
;
GO

-- VERSAO --
EXEC ATUVEROBJ 'CONHECIMENTO_TRANSPORTE','4.05.126';
GO

