function LSLoginService(requestDataSourceEngine, LSUtilities) {
    this.login = function(email, password, attempts, hash, confirmSessionChange) {
        var filter = [ {
            name: 'EMAIL',
            operator: '=',
            value: email
        }, {
            name: 'PASSWORD',
            operator: '=',
            value: password
        }, {
            name: 'PRODUCT_ID',
            operator: '=',
            value: window.projectId
        }, {
            name: 'REQUESTER_URL',
            operator: '=',
            value: document.location.href
        }, {
            name: 'ATTEMPTS',
            operator: '=',
            value: attempts
        }, {
            name: 'SHOW_FULL_OPERATOR',
            operator: '=',
            value: window.showFullOperatorWindow || false
        },  {
            name: 'HASH',
            operator: '=',
            value: hash
        }, {
            name: 'SESSION_CHANGE',
            operator: '=',
            value: confirmSessionChange
        }, {
            name: 'KEEP_CONNECTED',
            operator: '=',
            value: localStorage.getItem('LOGIN_KEEP_CONNECTED') === 'Yes' ? 'S' : 'N'
        } ];

        return requestDataSourceEngine.getDataSource('login#/login', filter, 1, undefined, undefined, undefined, 120000);
    };

    this.requestNewPassword = function(email, style) {
        var filter = [ {
            name: 'EMAIL',
            operator: '=',
            value: email
        }, {
            name: 'STYLE',
            operator: '=',
            value: style
        } ];

        return requestDataSourceEngine.getDataSource('login#/requestNewPassword', filter, 1, undefined, undefined, undefined, 120000);
    };

    this.updatePassword = function(actualPassword, newPassword, newPasswordConfirmation, email) {
        var filter = [ {
            name: 'ACTUAL_PASSWORD',
            operator: '=',
            value: actualPassword
        }, {
            name: 'NEW_PASSWORD',
            operator: '=',
            value: newPassword
        }, {
            name: 'CONFIRM_NEW_PASSWORD',
            operator: '=',
            value: newPasswordConfirmation
        }, {
            name: 'EMAIL',
            operator: '=',
            value: email
        } ];

        return requestDataSourceEngine.getDataSource('login#/updatePassword', filter, 1, undefined, undefined, undefined, 120000);
    };

    this.getProductLanguages = function() {
        var filter = [ {
            name: 'PRODUCT_ID',
            operator: '=',
            value: window.projectId
        } ];

        return requestDataSourceEngine.getDataSource('login#/productLanguages', filter, 1, undefined, undefined, undefined, 120000);
    };

    this.testLicenseConnection = function() {
        return requestDataSourceEngine.getDataSource('login#/testLicenseConnection', [], 1, undefined, undefined, undefined, 120000);
    };

    this.setLogAccess = function(userId) {
        var row = {
            USER_ID: userId
        };
        return LSUtilities.dataSource.setDataSource('login#/setLogAccess', [row]);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('LSLoginService', LSLoginService);
});
