<?php
/**
 * Created by PhpStorm.
 * User: wanderleijunior
 * Date: 28/03/19
 * Time: 13:13
 */

namespace Teknisa\ACL\Repositories;

use Teknisa\ACL\Util\InstanceProvider;
use Teknisa\Libs\Util\Environment;

class BaseCrud
{
    protected $table;
    protected $entityManager;
    /** @var Environment $libEnvironment */
    protected $libEnvironment;

    /**
     * Crud constructor.
     * @param string $table
     */
    public function __construct($table)
    {
        $this->entityManager = InstanceProvider::getEntityManager();
        $this->libEnvironment = InstanceProvider::getLibEnvironment();
        $this->table = $table;
    }

    /**
     * @param array $conditions
     * @param null $organizationId
     * @return array
     * @throws \Exception
     */
    public function findBy(array $conditions, $organizationId = null)
    {
        $filter = $this->buildConditions($conditions);
        $nrOrg = $organizationId ? $organizationId : $this->libEnvironment->getCurrentOrganizationId();
        $filter .= " AND NRORG = $nrOrg";
        $query = "SELECT * FROM {$this->table} {$filter}";
        return $this->entityManager->getConnection()->fetchAll($query);
    }

    public function findOneBy(array $conditions, $organizationId = null)
    {
        $filter = $this->buildConditions($conditions);
        $nrOrg = $organizationId ? $organizationId : $this->libEnvironment->getCurrentOrganizationId();
        $filter .= " AND NRORG = $nrOrg";
        $query = "SELECT * FROM {$this->table} {$filter}";
        return $this->entityManager->getConnection()->fetchAll($query)[0];
    }

    public function getTable()
    {
        return $this->table;
    }

    public function buildConditions(array $conditions)
    {
        if(!empty($conditions)){
            $count = count($conditions);
            $length = count($conditions);
            $condition =  'WHERE';
            foreach ($conditions as $key => $value) {
                $value = gettype($value) == 'string' ? "'{$value}'" : $value;
                if($count == $length){
                    $condition .= " {$key} = {$value}";
                } else {
                    $condition .= " AND {$key} = {$value}";
                }
                $count--;
            }
            return $condition;
        } else {
            throw new \Exception("Parâmetro array obrigatório.");
        }
    }

}